package nc.bs.report.queryconstruct;

import nc.bs.report.queryconstruct.IReportQueryTrans;
import nc.vo.fipub.query.ReportQueryVO;
import nc.vo.gfc.pub.FiSqlBuffer;

public class GlCashFlowReportQueryTrans implements IReportQueryTrans {

   public void transGfcQueryVO(ReportQueryVO vo) {
      vo.setWhereSqlForGlVoucher(this.getWhereSqlForGlVoucher(vo));
   }

   private String getWhereSqlForGlVoucher(ReportQueryVO vo) {
      FiSqlBuffer sql = new FiSqlBuffer();
      sql.append(" where ");
      sql.append("balance.dr", "<>", "1");
      if(!vo.isContainsUnEffect()) {
         sql.append(" and ");
         sql.append("balance.pk_managerv", "<>", "N/A");
      }

      if(null != vo.getPk_accoutingbook()) {
         sql.append(" and ");
         sql.append("balance.pk_accountingbook", vo.getPk_accoutingbook());
      }

      if(null != vo.getBegindate() && null != vo.getEnddate()) {
         sql.append(" and ");
         sql.append("balance.prepareddatev", ">=", vo.getBegindate().toString());
         sql.append(" and ");
         sql.append("balance.prepareddatev", "<=", vo.getEnddate().getDateAfter(1).toString());
      }

      if(vo.getIsmain().booleanValue()) {
         sql.append(" and ");
         sql.append("bd_cashflow.ismain", "Y");
      } else {
         sql.append(" and ");
         sql.append("bd_cashflow.ismain", "N");
      }

      if(null != vo.getM_Pk_CurrType()) {
         sql.append(" and ");
         sql.append("balance.pk_currtype", vo.getM_Pk_CurrType());
      }

      return sql.toString();
   }
}
